// Dialogs.cpp : implementation file
//

#include "stdafx.h"
#include "bkbmps.h"
#include "Dialogs.h"
#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CBmapDlg dialog


CBmapDlg::CBmapDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBmapDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CBmapDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CBmapDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBmapDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CBmapDlg, CDialog)
	//{{AFX_MSG_MAP(CBmapDlg)
	ON_WM_ERASEBKGND()
	ON_WM_CTLCOLOR()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBmapDlg message handlers
BOOL CBmapDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	CMainFrame* pFrm = (CMainFrame*)AfxGetMainWnd();
	CBitmap* dlgBmap;
	
	dlgBmap = &(pFrm->m_bkBmap);

    RECT rectClient;
    
    // Load hollow brush;
    m_brush.CreateStockObject(NULL_BRUSH);

    // Get bitmap information    
    dlgBmap->GetObject(sizeof(BITMAP), &m_bmInfo);

    GetClientRect(&rectClient);

    m_size.cx = rectClient.right;    // zero based
    m_size.cy = rectClient.bottom;    // zero based
    m_pt.x = rectClient.left;
    m_pt.y = rectClient.top;
    
    // Get temporary DC for dialog, will be released in dc destructor
    CClientDC dc(this);
    
    // Create compatible memory DC using the dialogs DC
    VERIFY(m_dcMem.CreateCompatibleDC(&dc));
    
	m_dcMem.SelectObject(dlgBmap);
    
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

BOOL CBmapDlg::OnEraseBkgnd(CDC* pDC) 
{
    pDC->StretchBlt(m_pt.x, m_pt.y, m_size.cx, m_size.cy, 
        &m_dcMem, 0, 0, m_bmInfo.bmWidth-1, m_bmInfo.bmHeight-1,
        SRCCOPY );
	return TRUE;
}

HBRUSH CBmapDlg::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
	CMainFrame* pFrm= (CMainFrame*)AfxGetMainWnd();

	if (pFrm->m_transparentText)
		pDC->SetBkMode(TRANSPARENT);

  //  pDC->SetTextColor(RGB(125, 125, 125));
    return (HBRUSH)m_brush;
}
/////////////////////////////////////////////////////////////////////////////
// CBmapBrushDlg dialog


CBmapBrushDlg::CBmapBrushDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBmapBrushDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CBmapBrushDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CBmapBrushDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBmapBrushDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CBmapBrushDlg, CDialog)
	//{{AFX_MSG_MAP(CBmapBrushDlg)
	ON_WM_CTLCOLOR()
	ON_WM_ERASEBKGND()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBmapBrushDlg message handlers

BOOL CBmapBrushDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	CMainFrame* pFrm = (CMainFrame*)AfxGetMainWnd();
	CBitmap* pDlgBmap;
	
	pDlgBmap = &(pFrm->m_bmapBrush);

    // Create bitmap brush;
    m_bkBrush.CreatePatternBrush(pDlgBmap);
    m_brush.CreateStockObject(NULL_BRUSH);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

HBRUSH CBmapBrushDlg::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
	CMainFrame* pFrm= (CMainFrame*)AfxGetMainWnd();

	if(pFrm->m_transparentText)
		pDC->SetBkMode(TRANSPARENT);

    return (HBRUSH)m_brush;
}

BOOL CBmapBrushDlg::OnEraseBkgnd(CDC* pDC) 
{
	CMainFrame* pFrm= (CMainFrame*)AfxGetMainWnd();
	CRect rectClient;

    GetClientRect(&rectClient);
	pDC->FillRect(&rectClient, &m_bkBrush);

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CBmapCenterDlg dialog


CBmapCenterDlg::CBmapCenterDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBmapCenterDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CBmapCenterDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CBmapCenterDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBmapCenterDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CBmapCenterDlg, CDialog)
	//{{AFX_MSG_MAP(CBmapCenterDlg)
	ON_WM_ERASEBKGND()
	ON_WM_CTLCOLOR()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBmapCenterDlg message handlers

BOOL CBmapCenterDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	CMainFrame* pFrm = (CMainFrame*)AfxGetMainWnd();
	CBitmap* dlgBmap;
	
	dlgBmap= &(pFrm->m_bmapCentered);

    RECT rectClient;
    
    //Load a hollow brush and create another 
	//brush with the default background color
    m_brush.CreateStockObject(NULL_BRUSH);
	m_bkBrush.CreateSolidBrush(::GetSysColor(COLOR_WINDOW));

    // Get bitmap information    
    dlgBmap->GetObject(sizeof(BITMAP), &m_bmInfo);

    GetClientRect(&rectClient);

	//Check to see if bitmap is larger than target area
	if (m_bmInfo.bmWidth > rectClient.right)
		m_size.cx = rectClient.right;
	else
		m_size.cx = m_bmInfo.bmWidth;     // zero based

	if (m_bmInfo.bmHeight > rectClient.bottom)
	    m_size.cy = rectClient.bottom;
	else
		m_size.cy = m_bmInfo.bmHeight;    // zero based

	m_pt.x = (rectClient.right - m_size.cx) / 2;
	m_pt.y = (rectClient.bottom - m_size.cy) / 2;
    
    // Get temporary DC for dialog, will be released in DC destructor
    CClientDC dc(this);
    
    // Create compatible memory DC using the dialog's DC
    VERIFY(m_dcMem.CreateCompatibleDC(&dc ));
    
	m_dcMem.SelectObject(dlgBmap);
    
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

BOOL CBmapCenterDlg::OnEraseBkgnd(CDC* pDC) 
{
	CDialog::OnEraseBkgnd(pDC);
    
	RECT rectClient;
    CBrush bkBrush;

    GetClientRect(&rectClient);
	pDC->FillRect(&rectClient, &m_bkBrush);

    pDC->BitBlt(m_pt.x, m_pt.y, m_size.cx, m_size.cy, 
        &m_dcMem, 0, 0, SRCCOPY);
	return TRUE;
}

HBRUSH CBmapCenterDlg::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
	CMainFrame* pFrm= (CMainFrame*)AfxGetMainWnd();

	if (pFrm->m_transparentText)
        pDC->SetBkMode(TRANSPARENT);

    return (HBRUSH)m_brush;
}
